      SUBROUTINE unmix_rrrng(lda,n,ia,ilow,ihgh,ia_vtx,ilow_vtx,
     &                       ihgh_vtx,ap,ap_scl,irep,iorder,
     &                       ia_new,ilow_new,ihgh_new,iorder_new,
     &                       ap_new,itmp)
 
      IMPLICIT NONE

!  .. Scalar variable ..

      INTEGER lda, n

!  .. Array variables ..

      INTEGER ia(lda,*), ia_vtx(lda,*)
      INTEGER ilow(*), ihgh(*), ilow_vtx(*), ihgh_vtx(*)
      INTEGER iorder(*), irep(*)
      COMPLEX*16 ap(*), ap_scl(*)

!  .. Purpose ..

!     For the unmixed case, rearrange the supports in the way:
!        For five supports, A1, A2, A3 are same and A4 and A5 are same, then
!        wr rearrange the supports into A1, A4, A1, A1, A4.
!     Also rearrange the coefficients ap according to the new order of ia.

!  .. Local array variables ..

      INTEGER    ia_new(lda,*)
      INTEGER    ilow_new(*), ihgh_new(*)
      INTEGER    iorder_new(*)
      COMPLEX*16 ap_new(*)
      INTEGER    itmp(*)

!  .. Local scalar variables ..
 
      INTEGER i, i1, j
      INTEGER ispp, icnt, ith
 
!  .. Executable code ..
 
      i = 1
      ispp = 0
      do while (i .LE. n)
         if(irep(i) .LT. 0) then
            ispp = ispp + 1
            itmp(ispp) = i
         endif
         i = i + 1
      enddo
      i = 1
      ith = 0
      do while(i .LE. n)
         if(irep(i) .LT. 0) then
            ith = ith + 1
            icnt = 1
            do j = i+1, n
               if(irep(j) .EQ. i) then
                  ispp = ispp + 1
                  icnt = icnt + 1
                  itmp(ispp) = j
               endif
            enddo
            irep(ith) = icnt  
         endif
         i = i + 1
      enddo

!     irep(i) = k : # of supports which are the same as the i-th base support.

!     To rearrange ia, ilow, ihgh, ap, ap_scl

      DO j = ilow(1), ihgh(n)
         DO i = 1, n
            ia_new(i,j) = ia(i,j)
         ENDDO
         ap_new(j) = ap(j)
      ENDDO
      icnt = ilow(1) - 1
      do i = 1, n
         do j = ilow(itmp(i)), ihgh(itmp(i))
            icnt = icnt + 1
            DO i1 = 1, n
               ia(i1,icnt) = ia_new(i1,j)
            ENDDO
            ap(icnt)   = ap_new(j)
         enddo
         ihgh_new(i) = icnt
      enddo
      ilow_new(1) = ilow(1)
      DO i = 2, n
         ilow_new(i) = ihgh_new(i-1) + 1
      ENDDO

      DO j = ilow(1), ihgh(n)
         ap_new(j) = ap_scl(j)
      ENDDO
      icnt = ilow(1) - 1
      do i = 1, n
         do j = ilow(itmp(i)), ihgh(itmp(i))
            icnt = icnt + 1
            ap_scl(icnt)   = ap_new(j)
         enddo
      enddo


!     To rearrange iorder which is the position of pts of the smaller system
!     in the original system

      DO j = ilow_vtx(1), ihgh_vtx(n)
         iorder_new(j) = iorder(j)
      ENDDO
      icnt = ilow(1) - 1
      do i = 1, n
         do j = ilow_vtx(itmp(i)), ihgh_vtx(itmp(i))
            icnt = icnt + 1
            iorder(icnt) = iorder_new(j) - (ilow(itmp(i)) - ilow_new(i))
         enddo
      enddo
 
      DO i = 1, n
         ilow(i) = ilow_new(i)
         ihgh(i) = ihgh_new(i)
      ENDDO
 
!     To rearrange ia_vtx, ilow_vtx, ihgh_vtx
 
      DO j = ilow_vtx(1), ihgh_vtx(n)
         DO i = 1, n
            ia_new(i,j) = ia_vtx(i,j)
         ENDDO
      ENDDO
      icnt = ilow_vtx(1) - 1
      do i = 1, n
         do j = ilow_vtx(itmp(i)), ihgh_vtx(itmp(i))
            icnt = icnt + 1
            DO i1 = 1, n
               ia_vtx(i1,icnt) = ia_new(i1,j)
            ENDDO
         enddo
         ihgh_new(i) = icnt
      enddo
      DO i = 1, n
         ihgh_vtx(i) = ihgh_new(i)
      ENDDO
      DO i = 2, n
         ilow_vtx(i) = ihgh_new(i-1) + 1
      ENDDO

      RETURN
      END
