      subroutine addpare(a,iyn)

      implicit none

      integer iyn

      CHARACTER*(*) a

!  .. Purpose

!      To determine whether it is necessary to add a pair of parentheses
!      around a to form the product of a with something else.
!  iyn = 0 : not necessary, use a*z form;
!      = 1 : necessary, must use (a)*z form.
!      Note that a can have only **, * and +, no / and -.

!  .. Function Called

      integer len_trim

!  .. Local Variables

      integer i

!  .. Executable Code 

      iyn = INDEX(a,'+')
      if ( iyn .NE. 0 ) then
         if ( a(1:1) .NE. '(' ) then
            iyn = 1
         else
            iyn = 0
            do i = 2, len_trim(a)-1
               if ( a(i:i) .EQ. '(' ) then
                  iyn = iyn + 1
               else
                  if ( a(i:i) .EQ. ')' ) iyn = iyn - 1
               endif
               if ( iyn .LT. 0 ) then
                  iyn = 1
                  return
               endif
            enddo
         endif
      endif

      iyn = 0

      return
      end
