      SUBROUTINE gen1fun(lda,n,ia,coef,iidx,a)

      IMPLICIT NONE

      INCLUDE 'genpdp.h'

!  .. Scalar variable ..

      INTEGER lda, n

!  .. Array Arguments

      INTEGER       ia(lda,*), iidx(lda,0:*)
      CHARACTER*(*) coef(*)
      CHARACTER*(*) a(lda,*)

!  .. PURPOSE ..
  
!     generates one polynomial. The polynomial can be printed by prnt.f
!     in FORTRAN form

!  .. Input and output ..

!     ia   - the support matrix
!     coef - coefficients of the terms
!     iidx - contains grouping information
!     a    - a(1,1) is the formula of the function

!  .. Functions called
!       i2c.f, len_trim.f

      INTEGER             len_trim
      CHARACTER*(len_i2c) i2c

!  .. Local Variables ..
      INTEGER icnt, i, i1, i2, itmp, itmp1, igpn, iyn
      CHARACTER*(len_i2c) c1, c2

!  .. Executable Statements ..

      icnt = 1
      igpn = 1
!     igpn is the corresponding group number in previous level

      c1 = i2c(n)
      do i1 = 1, iidx(n,0)

!        for each group

         if(iidx(n,i1) .eq. 1) then

!           one term case

            if(ia(n,icnt) .gt. 1) then

               c2 = i2c(ia(n,icnt))
               a(n,i1) = coef(igpn)(1:len_trim(coef(igpn))) 
     &          // '*z(' // c1(1:len_trim(c1)) // ')**' 
     &          // c2(1:len_trim(c2))

            else

               if(ia(n,icnt) .eq. 1) then
                  a(n,i1)= coef(igpn)(1:len_trim(coef(igpn))) // '*z('
     &                   // c1(1:len_trim(c1)) // ')' 
               else
                  a(n,i1)= coef(igpn)(1:len_trim(coef(igpn))) 
               endif

            endif

            igpn = igpn + 1

         else

!           multiple term case
!           to find how many terms in this group

            itmp1=0
            do i = icnt, icnt+iidx(n,i1)-2
               if(ia(n,i) .eq. ia(n,i+1)) then
                  itmp1=itmp1+1
               endif
            enddo

            a(n,i1)=' '
            do itmp=1,iidx(n,i1)-itmp1-1
               a(n,i1) = a(n,i1)(1:len_trim(a(n,i1))) // '('
            enddo

            a(n,i1) = a(n,i1)(1:len_trim(a(n,i1)))
     &              // coef(igpn)(1:len_trim(coef(igpn)))

            igpn = igpn + 1
            do i = icnt, icnt+iidx(n,i1)-2
               if(ia(n,i)-ia(n,i+1) .gt. 1) then
                  c2 = i2c(ia(n,i)-ia(n,i+1))
                  a(n,i1) = a(n,i1)(1:len_trim(a(n,i1)))
     &             // '*z(' // c1(1:len_trim(c1))
     &             // ')**' // c2(1:len_trim(c2))
     &             // '+' // coef(igpn)(1:len_trim(coef(igpn))) // ')'

                  igpn = igpn + 1
               else
                  if(ia(n,i)-ia(n,i+1) .eq. 1) then
                     a(n,i1) = a(n,i1)(1:len_trim(a(n,i1)))
     &                 // '*z(' // c1(1:len_trim(c1))
     &             // ')+' // coef(igpn)(1:len_trim(coef(igpn))) // ')'
                     igpn = igpn + 1
                  endif
               endif
            enddo
            i = icnt+iidx(n,i1)-1
            if(ia(n,i) .gt. 1) then
               c2 = i2c(ia(n,i))
               a(n,i1) = a(n,i1)(1:len_trim(a(n,i1)))
     &                 // '*z(' // c1(1:len_trim(c1)) // ')**'
     &                 // c2(1:len_trim(c2))
            else
               if(ia(n,i) .eq. 1) then
                  a(n,i1) = a(n,i1)(1:len_trim(a(n,i1)))
     &                // '*z(' // c1(1:len_trim(c1)) // ')'
               endif
            endif

         endif
         icnt = icnt + iidx(n,i1)

      enddo

      do i2 = n-1, 1, -1

         icnt = 1
         igpn = 1

!        igpn is the corresponding group number in previous level

         c1 = i2c(i2)
         do i1 = 1, iidx(i2,0)
!           for each group
            if(iidx(i2,i1) .eq. 1) then
!              one term case
               call addpare(a(i2+1,igpn),iyn)
               if(ia(i2,icnt) .gt. 1) then
                  if ( iyn .EQ. 1) then
                     c2 = i2c(ia(i2,icnt))
                     a(i2,i1) = '(' 
     &                // a(i2+1,igpn)(1:len_trim(a(i2+1,igpn))) // ')'
     &                // '*z(' // c1(1:len_trim(c1)) // ')**'
     &                // c2(1:len_trim(c2))
                  else
                     c2 = i2c(ia(i2,icnt))
                     a(i2,i1) = a(i2+1,igpn)(1:len_trim(a(i2+1,igpn)))
     &                // '*z(' // c1(1:len_trim(c1)) // ')**'
     &                // c2(1:len_trim(c2))
                  endif
               else
                  if(ia(i2,icnt) .eq. 1) then
                     if ( iyn .EQ. 1 ) then
                        a(i2,i1) = '(' 
     &                   // a(i2+1,igpn)(1:len_trim(a(i2+1,igpn))) 
     &                   // ')'
     &                   // '*z(' // c1(1:len_trim(c1)) // ')'
                     else
                        a(i2,i1)=a(i2+1,igpn)(1:len_trim(a(i2+1,igpn)))
     &                   // '*z(' // c1(1:len_trim(c1)) // ')'
                     endif
                  else
                     a(i2,i1) = a(i2+1,igpn)(1:len_trim(a(i2+1,igpn))) 
                  endif
               endif
               igpn = igpn + 1
            else
!              multiple term case
!              to find how many terms in this group
               itmp1=0
               do i = icnt, icnt+iidx(i2,i1)-2
                  if(ia(i2,i) .eq. ia(i2,i+1)) then
                     itmp1=itmp1+1
                  endif
               enddo

               a(i2,i1) = ' '
               do itmp=1,iidx(i2,i1)-itmp1-1
                  a(i2,i1) = a(i2,i1)(1:len_trim(a(i2,i1))) // '('
               enddo

               call addpare(a(i2+1,igpn),iyn)
               if (iyn .EQ. 1) then
                  a(i2,i1) = a(i2,i1)(1:len_trim(a(i2,i1)))
     &             // '(' // a(i2+1,igpn)(1:len_trim(a(i2+1,igpn))) 
     &             // ')'
               else
                  a(i2,i1) = a(i2,i1)(1:len_trim(a(i2,i1))) 
     &             // a(i2+1,igpn)(1:len_trim(a(i2+1,igpn)))
               endif

               igpn = igpn + 1

               do i = icnt, icnt+iidx(i2,i1)-2
                  call addpare(a(i2+1,igpn),iyn)
                  if(ia(i2,i)-ia(i2,i+1) .gt. 1) then
                     if (iyn .EQ. 1) then
                        c2 = i2c(ia(i2,i)-ia(i2,i+1))
                        a(i2,i1) = a(i2,i1)(1:len_trim(a(i2,i1)))
     &                   // '*z(' // c1(1:len_trim(c1)) // ')**'
     &                   // c2(1:len_trim(c2)) // '+(' 
     &                   // a(i2+1,igpn)(1:len_trim(a(i2+1,igpn)))
     &                   // '))'
                     else
                        c2 = i2c(ia(i2,i)-ia(i2,i+1))
                        a(i2,i1) = a(i2,i1)(1:len_trim(a(i2,i1)))
     &                   // '*z(' // c1(1:len_trim(c1))// ')**'
     &                   // c2(1:len_trim(c2)) // '+' 
     &                   // a(i2+1,igpn)(1:len_trim(a(i2+1,igpn)))
     &                   // ')'
                     endif
                     igpn = igpn + 1
                  else
                     if(ia(i2,i)-ia(i2,i+1) .eq. 1) then
                        if (iyn .EQ. 1) then
                           a(i2,i1) = a(i2,i1)(1:len_trim(a(i2,i1)))
     &                      // '*z(' // c1(1:len_trim(c1))
     &                      // ')+('
     &                      // a(i2+1,igpn)(1:len_trim(a(i2+1,igpn)))
     &                                // '))'
                        else
                           a(i2,i1) = a(i2,i1)(1:len_trim(a(i2,i1)))
     &                      // '*z(' // c1(1:len_trim(c1)) // ')+'
     &                      // a(i2+1,igpn)(1:len_trim(a(i2+1,igpn)))
     &                                // ')'
                        endif
                        igpn = igpn + 1
                     endif
                  endif
               enddo
               i = icnt+iidx(i2,i1)-1
               if(ia(i2,i) .gt. 1) then
                  c2 = i2c(ia(i2,i))
                  a(i2,i1) = a(i2,i1)(1:len_trim(a(i2,i1)))
     &             // '*z(' // c1(1:len_trim(c1))
     &             // ')**' // c2(1:len_trim(c2))
               else 
                  if(ia(i2,i) .eq. 1) then
                     a(i2,i1) = a(i2,i1)(1:len_trim(a(i2,i1)))
     &                // '*z(' // c1(1:len_trim(c1)) // ')'
                  endif
               endif

            endif
            icnt = icnt + iidx(i2,i1)
         enddo
      enddo

      RETURN
      END
