      SUBROUTINE group(lda,mia,nia,ia,iidx)

      IMPLICIT none

!  .. Scalar Variables

      INTEGER lda, nia, mia

!  .. Array Arguments ..

      INTEGER ia(lda,*)
      INTEGER iidx(lda,0:*)

!  .. PURPOSE ..
  
!     To find the grouping information on sorted ia

!  .. Input and output

!     ia   - The matrix to be arranged
!            mia - row dimension of ia
!            nia - column dimension of ia
!     iidx - The information for the grouping

!  .. Local variables .. 

      INTEGER  ngps, jgplow, jgphgh, jgp, idx, icnt
      INTEGER  i, i1

!  .. Executable code ..

      iidx(1,0) = 1
      iidx(1,1) = nia

      do i = 2, mia
         ngps = 0
         jgplow = 1

         do jgp = 1, iidx(i-1,0)
            jgphgh = jgplow + iidx(i-1,jgp) - 1
            icnt = 1
            idx = jgplow
 10         continue
            if(idx .lt. jgphgh) then
               do i1 = idx+1, jgphgh  
                  if(ia(i-1,i1) .eq. ia(i-1,idx)) then
                     icnt = icnt + 1
                  else
                     goto 20
                  endif
               enddo 
 20            continue
               ngps = ngps + 1
               iidx(i, ngps) = icnt
               idx = idx + icnt
               icnt = 1
               goto 10
            else 
               if(idx .eq. jgphgh) then
                  ngps = ngps + 1
                  iidx(i,ngps) = 1
               endif
            endif

            jgplow = jgphgh + 1
         enddo

         iidx(i,0) = ngps
      enddo

      return
      end
