      SUBROUTINE sort(lda,n,m,ia,ap)

      IMPLICIT NONE

!  .. Scalar variable ..

      INTEGER lda, n, m

!  .. Array Arguments ..

      INTEGER ia(lda,*)   ! ia is n by m
      COMPLEX*16 ap(*)    ! ap is 1 by m

!  .. Purpose ..
  
!     To sort support ia in lexcographically decending order
!     and rearrange the coefficients according to the new order of ia.

!  .. Local scalar variables ..

      INTEGER    i, idx, itmp, j
      COMPLEX*16 ctmp

!  .. External function called

      LOGICAL lex_gt

!  .. Executable Statements ..

      DO i = 1, m-1
         idx = i
         DO j = i+1, m
            IF ( lex_gt(n,ia(1,j),ia(1,idx)) ) idx = j
         ENDDO
 
         IF( idx .GT. i ) THEN
            DO j = 1, n
               itmp = ia(j,i)
               ia(j,i) = ia(j,idx)
               ia(j,idx) = itmp
            ENDDO
 
            ctmp    = ap(i)
            ap(i)   = ap(idx)
            ap(idx) = ctmp
         ENDIF
      ENDDO
 
      RETURN
      END
