      SUBROUTINE sort_supp(lda,n,ia,ap,ilow,ihgh)
 
      IMPLICIT NONE
 
!  .. Scalar variables ..

      INTEGER lda, n

!  .. Array Arguments ..

      INTEGER    ilow(*), ihgh(*)
      INTEGER    ia(lda,*)
      COMPLEX*16 ap(*)

!  .. Purpose ..
  
!     TO sort each support stored in ia in lexcographically descanding order.
!     The i-th support in ia is located between ilow(i) and ihgh(i).
!     The system of polynomials may not be square. n is the # of variables.

!  .. LOCAL VARIABLES ..

      INTEGER i, nospp

!  .. Executable code ..

      nospp = n  ! no of supports
 
      DO i = 1, nospp
         CALL sort(lda,n,ihgh(i)-ilow(i)+1,ia(1,ilow(i)),ap(ilow(i)))
      ENDDO
 
      RETURN
      END
