      SUBROUTINE chck_rtseq(lda,n,roots,nrts,ntimes,hnrm,dhegn,yesno)

      IMPLICIT NONE

      include '../global.h'

!  .. Scalar variables ..

      INTEGER lda, n, nrts
      LOGICAL yesno

!  .. Array variables ..

      INTEGER ntimes(*)
      DOUBLE PRECISION hnrm(*), dhegn(*)
      COMPLEX*16 roots(lda,*)

!  .. Purpose ..

!     For all the roots with ntimes(:)<0, check whether they are
!     numerically close to each other. And if at the points the Jaconbian
!     matrix are not singular, set the corresponding ntimes(:)=-ntimes(:)+1.

!  .. Local scalar variables ..

      INTEGER  i, icnt, j, j1
      DOUBLE PRECISION min_diff, dtmp
      LOGICAL yn_snglr

!  .. Executable ..

      min_diff = 1.0d-5

      DO j = 1, nrts-1
         IF(ntimes(j) .LT. 0) THEN
            yn_snglr = .TRUE.
            icnt = 0
            DO j1 = j+1, nrts
               IF(ntimes(j1) .LT. 0) THEN
                  dtmp = 0.0d0
                  DO i = 1, n
                     dtmp = MAX(dtmp,ABS(roots(i,j1)-roots(i,j)))
                  ENDDO
                  IF(dtmp .LT. min_diff*0.1d0) then
                     IF(.NOT. yn_snglr) THEN
                        ntimes(j1) = -ntimes(j1) + 1
                        icnt = icnt + 1
                     ELSE
                        IF(dhegn(j) .GT. min_diff) THEN
                           yn_snglr = .FALSE.
                           ntimes(j1) = -ntimes(j1) + 1
                           icnt = icnt + 1
                           yesno = .TRUE.
                        ELSE
                           GOTO 10
                        ENDIF
                     ENDIF
                  ENDIF
               ENDIF
            ENDDO
            IF(.NOT. yn_snglr) THEN
               ntimes(j) = -ntimes(j) + 1

               IF(debug) THEN
                  WRITE(10,*)  icnt+1, 'roots are equal in a group'
               ENDIF
            ENDIF
         ENDIF
 10   ENDDO

      END
