      SUBROUTINE connum(lda,n,ap,x,dp,cnnm)

      IMPLICIT NONE

!  .. Scalar variables ..

      INTEGER lda, n
      DOUBLE PRECISION cnnm

!  .. Array variables ..

      COMPLEX*16 ap(*), x(*), dp(lda,*)


!  .. Purpose ..

!     Find the norm of the smallest eigenvalue of the Jacobian matrix at x

!  .. Local scalar variables ..

      INTEGER  i, j, info

!  .. Local array variables ..

      integer   ndim
      parameter (ndim = 200)
      DOUBLE PRECISION ar(ndim,ndim), ai(ndim,ndim), wr(ndim), 
     &                 wi(ndim), zr(ndim,ndim), zi(ndim,ndim), 
     &                 fv1(ndim), fv2(ndim), fv3(ndim)

!  .. Executable ..

      IF ( ndim .lt. n ) THEN
         WRITE(*,*)  'In FLLWCRV/connum.f, make ndim > n'
         WRITE(*,*)  'Then recompile and rerun fllwcrv. Sorry.'
         STOP
      ENDIF

      CALL zgetdp(lda,ap,x,dp)
      DO j = 1, n
         DO i = 1, n
            ar(i,j) = DBLE(dp(i,j))
            ai(i,j) = DIMAG(dp(i,j))
         ENDDO
      ENDDO
      CALL cg(ndim,n,ar,ai,wr,wi,0,zr,zi,fv1,fv2,fv3,info)
      cnnm = 1.0d150
      DO i = 1, n
         cnnm = MIN(cnnm,ABS(wr(i))+ABS(wi(i)))
      ENDDO

      END
