      SUBROUTINE rts_prnt(lda,n,roots,nrts,ntimes,hnrm,dhegn)

      IMPLICIT NONE

!  .. Scalar variables ..

      INTEGER lda, n, nrts

!  .. Array variables ..

      INTEGER ntimes(*)
      COMPLEX*16 roots(lda,*)
      DOUBLE PRECISION hnrm(*), dhegn(*)

!  .. Purpose ..

!     To find the condition for each root and print the root and its related
!     information.

!  .. Local scalar variables ..

      INTEGER          i, ngood, nbad, j, j1, nreal, nmissed
      DOUBLE PRECISION min_cond, min_diff, dtmp
      LOGICAL          yn_mtpl, yn_real

!  .. Executable code ..

      min_cond = 1.0d-8
c     min_cond = 1.0d-5      ! 522
      min_diff = 1.0d-4

      nmissed = 0
      ngood = 0
      nbad  = 0
      nreal = 0
c     WRITE(10,*) 'Following roots are missing after scalled back' 
      DO j = 1, nrts

         IF(ntimes(j) .LT. 0 .and. abs(hnrm(j)) .lt. 1.0) then

            yn_real = .TRUE.
            do i = 1, n                                   ! added 522
               if(abs(DIMAG(roots(i,j))) .GT. 1.0d-3)
     &               yn_real = .FALSE.
            enddo 

            IF(dhegn(j) .LT. min_cond) THEN
               yn_mtpl = .FALSE.
               DO j1 = j+1, nrts
                  IF(ntimes(j1) .LT. 0 .and. 
     &                             abs(hnrm(j)) .lt. 1.0) THEN
                     dtmp = 0.0d0
                     DO i = 1, n
                        dtmp = MAX(dtmp,ABS(roots(i,j1)-roots(i,j)))
                     ENDDO
                     IF(dtmp .LT. min_diff) THEN
                        yn_mtpl = .TRUE.
                        ntimes(j1) = -ntimes(j1)
                        ngood = ngood + 1
                        if (yn_real) nreal = nreal + 1
                        WRITE(2,*) j1,                                   
     &                     ' A multiple root with smallest eigenvalue ',
     &                     dhegn(j1)
                        DO i = 1, n
                           WRITE(2,*) roots(i,j1)
                        ENDDO
                        WRITE(2,*)'Max polynomial value at the root : ', 
     &                             hnrm(j1)
                        WRITE(2,*) ' '
                     ENDIF
                  ENDIF
               ENDDO
               IF(yn_mtpl) THEN
                  ngood = ngood + 1
                  if (yn_real) nreal = nreal + 1
                  WRITE(2,*) j,                                         
     &                     ' A multiple root with smallest eigenvalue ',
     &                       dhegn(j)
                  DO i = 1, n
                     WRITE(2,*) roots(i,j)
                  ENDDO
                  WRITE(2,*) 'Max polynomial value at the root : ', 
     &                        hnrm(j)
                  WRITE(2,*) ' '
               ELSE
                  nbad = nbad + 1
                  if (yn_real) nreal = nreal + 1
                  WRITE(2,*) j,
     &           ' An ill-conditioned root with smallest eigenvalue ', 
     &                 dhegn(j)
                  DO i = 1, n
                     WRITE(2,*) roots(i,j)
                  ENDDO
                  WRITE(2,*) 'Max polynomial value at the root : ',
     &                        hnrm(j)
                  WRITE(2,*) ' '
               ENDIF
            ELSE
               DO j1 = j+1, nrts
                  IF(ntimes(j1) .LT. 0 
     &                       .and. abs(hnrm(j)) .lt. 1.0) THEN
                     dtmp = 0.0d0
                     DO i = 1, n
                        dtmp = MAX(dtmp,ABS(roots(i,j1)-roots(i,j)))
                     ENDDO
                     IF(dtmp .LT. min_diff) THEN
                         WRITE(2,*) j, j1,'-th roots are very close'
                     ENDIF
                  ENDIF
               ENDDO
               ngood = ngood + 1
               if (yn_real) nreal = nreal + 1
               WRITE(2,*) j, 
     &            ' A simple root with smallest eigenvalue ', dhegn(j)
               DO i = 1, n
                  WRITE(2,*) roots(i,j)
               ENDDO
               WRITE(2,*) 'Max polynomial value at the root : ', 
     &                     hnrm(j)
               WRITE(2,*) ' '
            ENDIF
            ntimes(j) = -ntimes(j)
         ELSE
           IF(ntimes(j) .LT. 0) then
             WRITE(10,*) j, '-th, max function value at the root =', 
     &       abs(hnrm(j))
             ntimes(j) = 4444
             nmissed = nmissed + 1
           ENDIF
         ENDIF

      ENDDO

c     if (nmissed .gt. 0) then
c       WRITE(2,*) ' '
c       WRITE(2,*) '======================================'
c       WRITE(2,*) 'After scalled back,',
c    &    'the program does not accept the following as roots:' 
c       DO j = 1, nrts

c        IF(ntimes(j) .EQ. 4444) then
c           WRITE(2,*) j, 
c    &         ' missing after scalled back '
c           DO i = 1, n
c              WRITE(2,*) roots(i,j)
c           ENDDO
c           WRITE(2,*) 'Max polynomial value at the root : ', 
c    &                  hnrm(j)
c           WRITE(2,*) ' '
c        ENDIF

c       ENDDO
c       WRITE(2,*) 'Above ', nmissed, 
c    &    ' roots were not accepted as roots after scalled back.' 
c       WRITE(2,*) '======================================'
c       WRITE(2,*) ' '
c     endif

      WRITE(2,*) 'Total number of roots found  : ', ngood+nbad
      WRITE(2,*) 'Total number of real roots found : ', nreal
      WRITE(2,*) 'Total number of good-conditioned roots  : ', ngood
      WRITE(2,*) 'Total number of ill-conditioned roots  : ', nbad
      WRITE(10,*) 'Total number of roots found : ', ngood+nbad
      WRITE(10,*) 'Total number of real roots >= ', nreal
      WRITE(10,*) '     # of real roots depends on the threshold set'
      WRITE(10,*) 'Total number of good-conditioned roots  : ', ngood
      WRITE(10,*) 'Total number of ill-conditioned roots  : ', nbad

      END
