      SUBROUTINE rts_refine(lda,n,roots,mvl,scl,ntimes,
     &                      ap_scl,ap_real,ap,
     &                      yn_real,
     &                      dhz,h,x,zdhz,zh,zx,hnrm,dhegn)

      IMPLICIT NONE

      include '../global.h'

!  .. Purpose ..

!     Scale all roots back to that of the original variables. 

!  .. Scalar variables ..

      INTEGER lda, n, mvl
      LOGICAL yn_real

!  .. Array variables ..

      INTEGER          ntimes(*)
      DOUBLE PRECISION scl(*), hnrm(*), dhegn(*)
      DOUBLE PRECISION ap_real(*), dhz(lda,*), h(*), x(*)
      COMPLEX*16       ap_scl(*), ap(*), roots(lda,*)

!  .. Local scalar variables ..

      INTEGER i, j, info, icnt, iter
      DOUBLE PRECISION dtmp

!  .. Local array variables ..

      COMPLEX*16 zdhz(lda,*), zh(*), zx(*)

!  .. Executable ..

      IF(yn_real) THEN
         DO j = 1, mvl
            IF(ntimes(j) .LT. 0) THEN
               yn_real = .TRUE.
               DO i = 1, n
                  IF(ABS(DIMAG(roots(i,j))) .GT. 1.0d-4)
     &               yn_real = .FALSE.
               ENDDO
               IF(yn_real) THEN

                  DO i = 1, n
                     x(i) = DBLE(roots(i,j))
                  ENDDO
                  iter = 0
                  CALL zgetpr(ap_real,x,h)
                  DO WHILE (iter .LT. gmax_nwtn)
                     CALL zgetdpr(lda,ap_real,x,dhz)
                     CALL dhshld_slv(lda,n,dhz,h,info)
                     IF(info .EQ. 1) GOTO 10
                     DO i = 1, n
                        x(i) = x(i) - h(i)
                     ENDDO
                     CALL zgetpr(ap_real,x,h)

                     dtmp = 0.0d0
                     DO i = 1, n
                        dtmp = MAX(dtmp,ABS(h(i)))
                     ENDDO
                     IF ( dtmp .GT. 1.0d-3 ) GOTO 10

                     iter = iter + 1
                  ENDDO

                  IF(debug) THEN
                    WRITE(10,*) 'Refine the real : ', dtmp
                  ENDIF
                  IF(dtmp .LT. 0.0001d0) THEN
                     DO i = 1, n
                        roots(i,j) = x(i)
                     ENDDO
                     hnrm(j) = dtmp
                  ENDIF
               ELSE
                  CALL fnl_iter(lda,n,ap_scl,roots(1,j),zx,info,
     &                          zdhz,zh,hnrm(j))
               ENDIF

               IF (abs(dhegn(j)) .LT. 0.1d0) THEN
                  CALL connum(lda,n,ap_scl,roots(1,j),zdhz,dhegn(j))
               ENDIF

            ENDIF
 10      ENDDO

      ELSE

         DO j = 1, mvl
            IF(ntimes(j) .LT. 0) THEN
               CALL fnl_iter(lda,n,ap_scl,roots(1,j),zx,info,
     &                       zdhz,zh,hnrm(j))
               IF (abs(dhegn(j)) .LT. 0.1d0) THEN
                  CALL connum(lda,n,ap_scl,roots(1,j),zdhz,dhegn(j))
               ENDIF
            ENDIF
         ENDDO

      ENDIF

      icnt = 0
      DO i = 1, n
         h(i) = 10.0d0**scl(i)
      ENDDO

      DO i = 1, n
         IF(ABS(scl(i)) .GT. 1.0d-5) GOTO 15
      ENDDO
      DO j = 1, mvl
         IF(ntimes(j) .LT. 0) THEN
            DO i = 1, n
               roots(i,j) = roots(i,j)*h(i)
            ENDDO
            DO i = 1, n
               IF (ABS(DIMAG(roots(i,j))) .GT. 1.0d-5) GOTO 12
            ENDDO
            icnt = icnt + 1
         ENDIF
 12   ENDDO
      GOTO 30

 15   DO j = 1, mvl
         IF(ntimes(j) .LT. 0) THEN
            DO i = 1, n
               roots(i,j) = roots(i,j)*h(i)
            ENDDO
            CALL fnl_iter(lda,n,ap,roots(1,j),zx,info,zdhz,zh,hnrm(j))
            DO i = 1, n
               IF (ABS(DIMAG(roots(i,j))) .GT. 1.0d-5) GOTO 20
            ENDDO
            icnt = icnt + 1
         ENDIF
 20   ENDDO

 30   RETURN
c     IF (debug) THEN
c        WRITE(2,*) 'Total number of real roots >= : ', icnt
c        WRITE(2,*) ' '
c        WRITE(10,*) 'Total number of real roots >= : ', icnt
c        WRITE(10,*) ' '
c     ENDIF

c     RETURN
      END
