      subroutine zhshld_slv(lda,n,a,b,info)
*
      implicit none
*
*  .. Scalar Arguments ..
      integer n,info,lda
*  .. Array Arguments ..
      complex*16 a(lda,*),b(*)
      complex*16 v(200)
*
*  purpose
*  ======= 
*	Use household tansformation to change a into QR and
*       b into Qb. Q is not saved. R repalces A and Qb replace b
*
*  -- Written on 6/15/1996
*     Tangan Gao, Dept. of Math, Michigan State University
*
*
* a(n,n)   is the matrix. On entry, a is the coefficietn matrix
*          on exit, a is R. 
*          no information on the lower part of a.
* b(n,mb)  is the right side of a*x=b. mb may be 1 or 2
* mb       is the number of columns of b
* work(n)  is the work space
* info = 0 : everything is OK
*      = 1 : a is not of full rank
*
*  .. Local Variables ..
      complex*16  zzero
      parameter (zzero=(0.0d+0,0.0d+0))
      double precision zero, one
      parameter (zero=0.0d+0, one=1.0d+0)
      integer i,j,ix
      double precision scale,scale1,ssq,ssq1,norm,temp,eps 
      complex*16       ztemp
*
*  .. Executable Code ..
*
      info=0
      eps=1.0d-13
*
      do i=1,n-1
*        to copy the column considering and make a(ix,i) zero
         do ix=i,n
            v(ix)=a(ix,i)
         enddo
*        to get the norm of the vector first
*        next loop is from blas
         scale=zero
         ssq  =one
         do ix=i+1,n
            if(dble(v(ix)) .ne. zero) then
               temp=abs(dble(v(ix)))
               if(scale .lt. temp) then
                  ssq=one+ssq*(scale/temp)**2
                  scale=temp
               else
                  ssq=ssq+(temp/scale)**2
               endif
            endif
            if(dimag(v(ix)) .ne. zero) then
               temp=abs(dimag(v(ix)))
               if(scale .lt. temp) then
                  ssq=one+ssq*(scale/temp)**2
                  scale=temp
               else
                  ssq=ssq+(temp/scale)**2
               endif
            endif
         enddo
*
         ssq1=ssq
         scale1=scale
*        ssq1 and scale1 are for later use
*
         if(dble(v(i)) .ne. zero) then 
            temp=abs(dble(v(i))) 
            if(scale .lt. temp) then 
               ssq=one+ssq*(scale/temp)**2 
               scale=temp 
            else 
               ssq=ssq+(temp/scale)**2
            endif
         endif
         if(dimag(v(i)) .ne. zero) then
            temp=abs(dimag(v(i)))
            if(scale .lt. temp) then
               ssq=one+ssq*(scale/temp)**2
               scale=temp
            else
               ssq=ssq+(temp/scale)**2
            endif
         endif
         norm=scale*sqrt(ssq) 
*        got the norm
*
         if(norm .le. eps) then
            info = 1
            print*,'singularity in household.f'
            return
         endif
*
         a(i,i)=norm*(a(i,i)/abs(a(i,i)))
*
*        to form the vector v for household method. 
         v(i)=v(i)-a(i,i)
*
*        to get the norm of v. use the ssq1 and scale1 above
         if(dble(v(i)) .ne. zero) then 
            temp=abs(dble(v(i))) 
            if(scale1 .lt. temp) then 
               ssq1=one+ssq1*(scale1/temp)**2 
               scale1=temp 
            else 
               ssq1=ssq1+(temp/scale1)**2
            endif
         endif
         if(dimag(v(i)) .ne. zero) then
            temp=abs(dimag(v(i)))
            if(scale1 .lt. temp) then
               ssq1=one+ssq1*(scale1/temp)**2
               scale1=temp
            else
               ssq1=ssq1+(temp/scale1)**2
            endif
         endif
         norm=scale1*sqrt(ssq1)
*        have got the norm of v
*
         if(norm .le. eps) then
            goto 10
*           v for household method is zero, done
         endif
*
*        to form the unit vector
         do ix=i,n
            v(ix)=v(ix)/norm
         enddo
*
*        apply the transformation to a
         do j=i+1,n
            ztemp=zzero
            do ix=i,n
               ztemp=ztemp+dconjg(v(ix))*a(ix,j)
            enddo
            ztemp=2*ztemp
            do ix=i,n
               a(ix,j)=a(ix,j)-ztemp*v(ix)
            enddo
         enddo
*
*        apply to b
         ztemp=zzero
         do ix=i,n
            ztemp=ztemp+dconjg(v(ix))*b(ix)
         enddo
         ztemp=2*ztemp
         do ix=i,n
            b(ix)=b(ix)-ztemp*v(ix)
         enddo
 10   enddo
      if(abs(a(n,n)) .le. eps) info = 1
*
      return
      end
