	double precision function dznrm2(n,x)
*
	implicit none
*
	integer     n
	complex*16  x(*)
*
*	dznrm2 returns the 2-norm of the complex vector x(*)
*
	double precision    one,  zero
        parameter         (one = 1.0d+0, zero=0.0d+0)
*
	integer   ix
        double precision norm, scale, ssq, temp
*
c	intrinsic  abs, dimag, dble, sqrt
*
*
	if(n .lt. 1) then
	   norm=zero
	else
	   scale=zero
 	   ssq  =one
           do ix=1,n
              if(dble(x(ix)) .ne. zero) then
                 temp=abs(dble(x(ix)))
	         if(scale .lt. temp) then
                    ssq=one+ssq*(scale/temp)**2
	            scale=temp
                 else
	            ssq=ssq+(temp/scale)**2
                 endif
              endif
              if(dimag(x(ix)) .ne. zero) then
                 temp=abs(dimag(x(ix)))
                 if(scale .lt. temp) then
                    ssq=one+ssq*(scale/temp)**2
                    scale=temp
                 else
                    ssq=ssq+(temp/scale)**2
                 endif
              endif
	   enddo
	   norm=scale*sqrt(ssq)
	endif
*
	dznrm2=norm
*
	return
	end


