      SUBROUTINE zhermite3(n,p1,v1,h_old,p2,v2,h_new,p0)

      IMPLICIT none

!  .. Scalar Arguments ..

      INTEGER n

!  .. Array Arguments ..

      COMPLEX*16 p1(*), v1(*), p2(*), v2(*), p0(*)
      DOUBLE PRECISION h_old, h_new

!     COMPLEX(KIND=wp), DIMENSION(n), INTENT(IN) :: p1, v1, p2, v2
!     COMPLEX(KIND=wp), DIMENSION(n), INTENT(OUT) :: p0

!  .. Purpose ..

!     To use hermite cubic interpolation to predict next point

!  .. Input and output ..

! n       (input)the number of polynomials in the system
! p1=(z1) (input)the the first of the last two points known on curve
! v1      (input)the tangent vector at p1
! p2=(z2) (input)the last point known on the curve
! v2      (input)the tangent vector at p2
! h_old   (input)the step size to get p2 from p1
! h_new   (input)the step size to predict p0
! p0      (output) the point predicted

!  .. Local Variables ..

      INTEGER  i
      DOUBLE PRECISION temp

!  .. Executable Code ..

      temp = (h_old+h_new)/h_old

      DO i = 1, n
         p0(i) = p1(i)+v1(i)*h_old*temp                                      
     &           +(3*(p2(i)-p1(i))-(v2(i)+2*v1(i))*h_old)*temp**2            
     &           +((v2(i)+v1(i))*h_old+2*(p1(i)-p2(i)))*temp**3
      ENDDO

      RETURN
      END
