      SUBROUTINE znpath1(lda,n,ilow,ihgh,ap,tpwr,roots0,        
     &                   ith,rtlow,rthgh,roots1,nrts,ntimes,
     &                   p0, p1,
     &                   p2,v1,v2,dhz,h,p3,cf)

      IMPLICIT none

      include '../global.h'

!  .. Scalar Arguments ..

      INTEGER lda, n, ith, nrts

!  .. Array Arguments ..

      INTEGER ilow(*), ihgh(*), rtlow(*), rthgh(*), ntimes(*)
      DOUBLE PRECISION tpwr(*)
      COMPLEX*16 ap(*), roots0(lda,*), roots1(lda,*)

!  .. Local array variables ..

      COMPLEX*16 p0(*), p1(*)

      COMPLEX*16 p2(*), v1(*), v2(*),
     &           dhz(lda,*), h(*), p3(*), cf(*)

!  .. PURPOSE ..

!     This is to follow all homotopy curves

!  .. Input and output ..

! roots0  The initial roots for the homotopy at t=0.
! roots1  The roots of the target system(at t=1)
! ith     Considering the ith-th lower facet
! nrts    The total number of roots got so far
!
!       during processing:
!
! p0      The point on on the curve at t=0.
! p1      The point on on the curve at t=1.

!  .. Local Variables ..

      INTEGER  i, j, info

!  .. Executable Code ..

      IF(debug) THEN
        DO j = ilow(1), ihgh(n)
           WRITE(10,*) tpwr(j)
        ENDDO
      ENDIF
      DO j = rtlow(ith), rthgh(ith)
         IF(debug) THEN
           WRITE(10,*) ' '
           WRITE(10,*)'Tracing ',j,'-th path of nonlinear homotopy:'
         ENDIF

         DO i = 1, n
            p0(i) = roots0(i,j)
         ENDDO

         CALL zonepth1(lda,n,ilow,ihgh,ap,tpwr,p0,p1,ntimes(j),info,
     &                 p2,v1,v2,dhz,h,p3,cf)
         IF(info .eq. -1) THEN
            nrts = nrts + 1
            ntimes(j) = 1
            DO i = 1, n
               roots1(i,j) = p1(i)
            ENDDO
         ELSE
            ntimes(j) = 0                              !! curve tracing failed
         ENDIF
      ENDDO

      RETURN
      END
