      SUBROUTINE dformu(lda,n,a,u)
 
      IMPLICIT none
 
!  .. Scalar variable ..
 
      INTEGER lda, n
 
!  .. Array Arguments ..
 
      DOUBLE PRECISION a(lda,*), u(lda,*)
 
!  PURPOSE
!  =======
!     Find a integer matrix u such that ua is upper triangular
!     with det(u)=1 or -1
!
!  a     - double precision array of dimension n by n with 
!          integer entries (input/output)
!          on exit, a is the upper triangular matrix
!  u     - double precision array of dimension n by n(output)
!  utmp  - workspace, double precison of dimension of n by n
 
!  .. Local Variables ..
 
      INTEGER d, info, i, j, j1, k, l, itmp 
      DOUBLE PRECISION tmp1
 
!  .. Executable code ..
 
      do j = 1, n
         do i = 1, n
            u(i,j) = 0.0d0
         enddo
         u(j,j) = 1.0d0
      enddo
!
      do j = 1, n
         u(j,j) = 1.0d0
      enddo
!
      do j = 1, n-1
!        for each column
         do i=j+1,n
            call gcd1(nint(a(j,j)),nint(a(i,j)),d,k,l,itmp)
            if(itmp .ge. 0) then
               if(d .lt. 0) then
                  d=-d
                  k=-k
                  l=-l
               endif
               if(itmp .eq. 0) info=1
               if(itmp .gt. 0) then
                  do j1=1,n
                     tmp1 =u(j,j1)*k+u(i,j1)*l
                     u(i,j1) =u(j,j1)*(-a(i,j)/d)+u(i,j1)*
     &                                (nint(a(j,j))/d)
                     u(j,j1) =tmp1
                  enddo
                  do j1 = j+1, n
                     tmp1 =a(j,j1)*k+a(i,j1)*l
                     a(i,j1) =a(j,j1)*(-a(i,j)/d)+a(i,j1)*
     &                                (nint(a(j,j))/d)
                     a(j,j1) =tmp1
                  enddo
                  a(j,j) = d
                  a(i,j) = 0
               endif
            endif
         enddo
      enddo
      if(a(n,n) .lt. -1.0d-10) then
         a(n,n) = -a(n,n)
         do i=1,n
            u(n,i) = -u(n,i)
         enddo
      endif
!
      return
      end

