      SUBROUTINE gcd1(a,b,d,k,l,info)
 
      IMPLICIT none
 
!  .. Scalar Arguments ..
 
      INTEGER  a,b,d,k,l,info
 
!  PURPOSE
!  =======
!	to find d=GCD(a,b)=ka+lb
!
!       input : a, b
!       output: d, k, l
!       a and b are not changed
!       info= 1: normal return
!             0: a=\=0 and b=0
!	     -1: a=b=0
!
!  .. Local Variables ..
 
      INTEGER          k0, l0, r1, r2, q, temp

!	Method: Use Euclidian algorithm.
!	Way to calculate k and l:
!	if     r1=k0 a+l0 b
!              r2=k a+ l b
!	       r3=r1 - r2 q
!       then
!              r3=(k0 a+ l0 b)-(k a+ l b)q
!                =(k0-k q)a+(l0-l q)b
!
!  .. Executable Code ..
!
      info=1

      if(a .eq. 0 .and. b .eq. 0) then
         info=-1
!        d = 0
         return
      endif

!     if one of a and b is 0, or if b|a or a|b, quick return
      if(a .eq. 0) then 
         d=b
         k=0
         l=1
         return
      endif
      if(b .eq. 0) then 
         d=a
         k=1
         l=0
         return
      endif
      if((a/b)*b .eq. a) then
         d=b
         k=0
         l=1
         return
      endif
      if((b/a)*a .eq. b) then
         d=a
         k=1
         l=0
         return
      endif
!
      if (abs(a) .gt. abs(b)) then
         r1=a
         r2=b
      else
         r1=b
         r2=a
      endif
!
      q=r1/r2
      temp=r1-r2*q 
      if ((r2/temp)*temp .eq. r2) then
!     if r=a-b*q is the GCD, done.
         d=temp
         k=1
         l=-q 
         if(abs(a) .lt. abs(b)) then
            temp=k
            k=l
            l=temp
         endif
         return
      endif

!     all other cases involve more than one division.
      k0=0
      l0=1
      k=1
      l=-q
 10   r1=r2
      r2=temp
      q=r1/r2
      temp=k
      k=k0-k*q
      k0=temp
      temp=l
      l=l0-l*q
      l0=temp
      temp=r1-r2*q
      if ((r2/temp)*temp .eq. r2) then 
         d=temp
         if(abs(a) .lt. abs(b)) then
            temp=k
            k=l
            l=temp
         endif
         return
      else
         goto 10
      endif
!        
      return
      end
