      SUBROUTINE stbl_slv(lda,n,a,b)
 
      IMPLICIT NONE
 
      INTEGER    lda, n
      COMPLEX*16 a(lda,*), b(*)
 
!  .. Purpose ..
!
!     To solve a x = b. In the situation here, a and b are random.
!     The condition of the system is excellent. No special care is needed.
!     The solution is stored in b on exit.
 
!  .. Local variables ..
 
      INTEGER          i, j, j1, itmp
      DOUBLE PRECISION smallnum, dtmp
      COMPLEX*16       ctmp
 
!  .. Executable ..
 
      smallnum = 1.0d-10
!
      DO i = 1, n-1
         dtmp = 0.0d0
         DO j = i+1, n
            IF(dtmp .LT. ABS(a(j,i))) THEN
               dtmp = ABS(a(j,i))
               itmp = j
            ENDIF
         ENDDO
         IF(dtmp .LT. smallnum) THEN 
            WRITE(*,*) 'initial system are linearly dependent'
            STOP
         ENDIF
         IF(itmp .GT. i) THEN
            DO j1 = i, n
               ctmp      = a(itmp,j1)
               a(itmp,j1) = a(i,j1)
               a(i,j1)    = ctmp
            ENDDO
            ctmp    = b(itmp)
            b(itmp) = b(i)
            b(i)    = ctmp
         ENDIF
         DO j = i+1, n
            IF(ABS(a(j,i)) .GT. 0.0d0) then
               DO j1 = i+1, n
                  a(j,j1) = a(j,j1) - a(i,j1)*(a(j,i)/a(i,i))
               ENDDO
               b(j)       = b(j)    - b(i)*(a(j,i)/a(i,i))
            ENDIF
            a(j,i) = 0.0d0
         ENDDO
      ENDDO
      IF(ABS(a(n,n)) .LT. smallnum) THEN
         WRITE(*,*) 'initial system are linearly dependent'
         STOP
      ENDIF
      b(n) = b(n)/a(n,n)
      DO i = n-1, 1, -1
         DO j = i+1, n
            b(i) = b(i) - a(i,j)*b(j)
         ENDDO
         b(i) = b(i)/a(i,i)
      ENDDO
!
      RETURN
      END
