      PROGRAM main_fllwcrv

      IMPLICIT none

!  .. Scalar variables ..

      INTEGER lda, tnop, maxmvl, maxncmb
      include 'dimension.h'
      include 'mixcells.h'

      INTEGER n, nrts

!  .. Array variables ..

      INTEGER ilow(lda), ihgh(lda), ntimes(maxmvl), iorder(tnop)
      COMPLEX*16 aq(tnop), ap(tnop), ap_scl(tnop), 
     &           roots0(lda,maxmvl), roots1(lda,maxmvl),
     &           cf(tnop), cft(tnop),
     &           p0(lda), p1(lda), v_old(lda), v_new(lda),
     &           dhz(lda,lda), h(lda), p2(lda)

      DOUBLE PRECISION alpha1(lda), alpha2(lda), rdhz(lda,lda),
     &                 scl(lda), ap_real(tnop), 
     &                 hnrm(maxmvl), dhegn(maxmvl)

!  PURPOSE
!  =======

!     Balancing the lifting.

!  .. Local variables ..

      INTEGER  i, j, itmp, ilowvtx, ihghvtx
c     real time(2)

!  .. Executable Code ..

!     Read the initial data file generated by preprocess.f90

      OPEN(UNIT=2, FILE='for.mixvol')
         READ(2,*) n, itmp

         READ(2,*) (j,i=1,itmp)
 
         DO i = 1, n
            READ(2,*) ilow(i), ihgh(i)
         ENDDO
 
         DO j = ilow(1), ihgh(n)
            READ(2,*) (itmp,i=1,n)
         ENDDO

         ilowvtx = ilow(1)
         ihghvtx = ihgh(n)

         DO j = ilowvtx, ihghvtx
            READ(2,*) iorder(j)
         ENDDO

         DO i = 1, n
            READ(2,*) ilow(i), ihgh(i)
         ENDDO

         DO j = ilow(1), ihgh(n)
            READ(2,*) (itmp,i=1,n)
         ENDDO

         do i = ilow(1), ihgh(n)
            READ(2,*) ap_scl(i)
         enddo
         do i = 1, n
            READ(2,*) scl(i)
         enddo
         do i = ilow(1), ihgh(n)
            READ(2,*) ap(i)
         enddo

      CLOSE(UNIT=2)

      OPEN(2, FILE='for.fllwcrv')
         DO i = ilowvtx, ihghvtx
            READ(2,*) cf(i)
         ENDDO
         READ(2,*) nrts
         DO j = 1, nrts
            READ(2,*) ntimes(j)
            DO i = 1, n
               READ(2,*) roots0(i,j)
            ENDDO
         ENDDO
      CLOSE(2)

      OPEN(10, FILE='trash.fllwcrv')

      IF ( lda .lt. n+2 .OR. tnop .lt. ihgh(n)+2 .OR.
     &     maxmvl .lt. nrts+2 ) then
         IF (lda .lt. n+2) then
            Write(10,*) 'lda is too small in main_fllwcrv.f'
         ENDIF
         IF (tnop .lt. ihgh(n)+2) then
            Write(10,*) 'tnop is too small in main_fllwcrv.f'
         ENDIF
         IF (maxmvl .lt. nrts+2) then
            Write(10,*) 'maxmvl is too small in main_fllwcrv.f'
         ENDIF
         WRITE(10,*) 'Correct the wrong parameters,'
         WRITE(10,*) 'then re-compile and re-run fllwcrv.'
         STOP
      ENDIF

      DO i = ilow(1), ihgh(n)
         aq(i) = 0.0d0
      ENDDO
      DO i = ilowvtx, ihghvtx
         aq(iorder(i)) = cf(i)
      ENDDO

      OPEN(2, FILE='data.roots')
      
c     CALL dtime(time)

      CALL znpath(lda,n,ilow,ihgh,aq,ap_scl,scl,ap,
     &            roots0,ntimes,nrts,roots1,
     &            ap_real,cft,p0,p1,
     &            v_old,v_new,dhz,alpha1,h,cf,alpha2,
     &            p2,rdhz,hnrm,dhegn)

c     CALL dtime(time)
c     WRITE(10,*) 'CPU time for the linear homotopy : ', time(1)
      print*, ' '
      print*, '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
      print*, 'Solutions are stored in the file:   data.roots'
      print*, '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'

      CLOSE(2)
      CLOSE(10)

      STOP
      END
