      PROGRAM main_lftng

      IMPLICIT none

!  .. Scalar variables ..

      INTEGER lda, tnop, maxmvl, maxncmb
      include 'dimension.h'
      include 'mixcells.h'

      INTEGER n, ns, ncmb

!  .. Array variables ..

      INTEGER ia(lda,tnop)
      INTEGER ilow(lda), ihgh(lda),
     &        irep(lda), ptscmb(2*lda*maxmvl)
      DOUBLE PRECISION lft(tnop)

      INTEGER          noe(2*maxncmb*tnop), nos(2*maxncmb*tnop), 
     &                 ja(2*maxncmb*tnop**2), 
     &                 ib(tnop), jtmp1(0:lda), jtmp2(0:lda)
c     DOUBLE PRECISION a(2*maxncmb*tnop**2), b(2*maxncmb*tnop), 
      DOUBLE PRECISION a(4*maxncmb*tnop*lda), b(2*maxncmb*tnop), 
     &                 binv(tnop,tnop), v(lda), vn(lda,2*lda), s(tnop)

!  PURPOSE
!  =======

!     Balancing the lifting.

!  .. Local variables ..

      INTEGER  i, j, isum
c     REAL time(2)

!  .. Executable Code ..

!     Read the initial data file generated by preprocess.f90

      OPEN(UNIT=10, FILE='trash.lftng')

      OPEN(UNIT=2, FILE='for.slvinit')
         READ(2,*) i
         IF (i .eq. 1) THEN
            WRITE(10,*) 'Initial data file for.slvinit ',
     &                   'was generated by the code lftng.'
            WRITE(10,*) 'This step is no longer necessary.'
            STOP
         ENDIF

         READ(2,*) n, ns

         READ(2,*) (irep(i),i=1,ns)
 
         DO i = 1, n
            READ(2,*) ilow(i), ihgh(i)
            ilow(i) = ilow(i) + 1
            ihgh(i) = ihgh(i) + 1
         ENDDO
 
         DO j = ilow(1), ihgh(n)
            READ(2,*) (ia(i,j),i=1,n)
         ENDDO

         DO j = ilow(1), ihgh(n)
            READ(2,*) lft(j)
         ENDDO

         READ(2,*) ncmb

         isum = ns
         DO i = 1, ns
            isum = isum + irep(i)
         enddo

         DO i = 1, ncmb*isum
            READ(2,*) ptscmb(i)
            ptscmb(i) = ptscmb(i) + 1
         ENDDO

      CLOSE(UNIT=2)

      IF (lda .lt. n+2 .OR. tnop .lt. ihgh(n)+2 .OR.
     &    2*lda*maxmvl .lt. ncmb*isum+2 .OR. maxncmb .lt. ncmb+2) then

         IF (lda .lt. n+2) then
            Write(10,*) 'lda is too small in main_lftng.f'
         ENDIF
         IF (tnop .lt. ihgh(n)+2) then
            Write(10,*) 'tnop is too small in main_lftng.f'
         ENDIF
         IF (2*lda*maxmvl .lt. ncmb*isum+2) then
            Write(10,*) 'maxmvl is too small in main_lftng.f'
         ENDIF
         IF (maxncmb .lt. ncmb+2) then
            Write(10,*) 'maxncmb is too small in main_lftng.f'
         ENDIF
         WRITE(10,*) 'prepro gives correct lda and tnop'
         WRITE(10,*) 'mixvol gives correct maxmvl and maxncmb'
         WRITE(10,*) 'Re-compile and re-run prepro, mixvol if not done'
         WRITE(10,*) 'Then re-compile and re-run lftng'
         STOP
      ENDIF

c     CALL dtime(time)

      CAll lftng_un(n,ia,lft,ilow,ihgh,ns,irep,ptscmb,ncmb,
     &              lda,tnop,
     &              noe,nos,ja,ib,jtmp1,jtmp2,
     &              a,b,binv,v,vn,s)

c     CALL dtime(time)

c     WRITE(10,*) 'CPU time for balancing : ', time(1)

      CLOSE(10)

      OPEN(UNIT=2, FILE='for.slvinit')

         WRITE(2,*) 1

         WRITE(2,*) n, ns

         WRITE(2,*) (irep(i),i=1,ns)

         DO i = 1, n
            WRITE(2,*) ilow(i)-1, ihgh(i)-1
         ENDDO

         DO j = ilow(1), ihgh(n)
            WRITE(2,*) (ia(i,j),i=1,n)
         ENDDO

         DO j = ilow(1), ihgh(n)
            WRITE(2,*) lft(j)
         ENDDO

         WRITE(2,*) ncmb

         isum = ns
         DO i = 1, ns
            isum = isum + irep(i)
         enddo

         DO i = 1, ncmb*isum
            WRITE(2,*) ptscmb(i)-1
         ENDDO
 
      CLOSE(2)

 20   STOP
      END
