      PROGRAM main_slvinit

      IMPLICIT none

!  .. Scalar variables ..

      INTEGER lda, tnop, maxmvl, maxncmb
      include 'dimension.h'
      include 'mixcells.h'

      INTEGER n, ns, ncmb, nrts

!  .. Array variables ..

      INTEGER ia(lda,tnop)
      INTEGER ilow(lda), ihgh(lda),
     &        irep(lda), ptscmb(2*lda*maxmvl),
     &        rtlow(maxncmb), rthgh(maxncmb)
      DOUBLE PRECISION lft(tnop), nrmlv(lda,maxncmb)
      COMPLEX*16 aq(tnop), roots0(lda,maxmvl), roots1(lda,maxmvl)

      DOUBLE PRECISION a(lda,lda), u(lda,lda), b1(lda)
      COMPLEX*16       b(lda), ca(lda,lda)

      INTEGER ntimes(maxmvl)
      DOUBLE PRECISION tpwr(tnop)
      COMPLEX*16 cf(tnop), p0(lda), p1(lda), p2(lda), p3(lda),
     &           v1(lda), v2(lda)


!  PURPOSE
!  =======

!     Balancing the lifting.

!  .. Local variables ..

      INTEGER  i, j, isum, iseed
      REAL dran2
c              , time(2)
      COMPLEX*16 ctmp

!  .. Executable Code ..

!     Read the initial data file generated by preprocess.f90

      OPEN(UNIT=10, FILE='trash.slvinit')

      OPEN(UNIT=2, FILE='for.slvinit')
         READ(2,*) ntimes(1)
!                            = 0, for.slvinit was generated by mixvol
!                            = 1, for.slvinit was generated by lftng

         READ(2,*) n, ns

         READ(2,*) (irep(i),i=1,ns)
 
         DO i = 1, n
            READ(2,*) ilow(i), ihgh(i)
         ENDDO
 
         DO j = ilow(1), ihgh(n)
            READ(2,*) (ia(i,j),i=1,n)
         ENDDO

         DO j = ilow(1), ihgh(n)
            READ(2,*) lft(j)
         ENDDO

         READ(2,*) ncmb

         isum = ns
         DO i = 1, ns
            isum = isum + irep(i)
         enddo

         DO i = 1, ncmb*isum
            READ(2,*) ptscmb(i)
         ENDDO

      CLOSE(UNIT=2)

      IF (lda .lt. n+2 .OR. tnop .lt. ihgh(n)+2 .OR.
     &    2*lda*maxmvl .lt. ncmb*isum+2 .OR. maxncmb .lt. ncmb+2) then
         IF (lda .lt. n+2) then
            Write(10,*) 'lda is too small in main_slvinit.f'
         ENDIF
         IF (tnop .lt. ihgh(n)+2) then
            Write(10,*) 'tnop is too small in main_slvinit.f'
         ENDIF
         IF (2*lda*maxmvl .lt. ncmb*isum+2) then
            Write(10,*) 'maxmvl is too small in main_slvinit.f'
         ENDIF
         IF (maxncmb .lt. ncmb+2) then
            Write(10,*) 'maxncmb is too small in main_slvinit.f'
         ENDIF
         WRITE(10,*) ' '
         WRITE(10,*) 'Correct the wrong parameters, '
         WRITE(10,*) 'then re-compile and re-run slvinit'
         STOP
      ENDIF

c     CALL dtime(time)

      OPEN(4,file='SRC/SOLVER/iseed.dat')
          READ(4,*) iseed
      CLOSE(4)
      do i = 1, n
         ctmp=5.0d0*cmplx(1.0d0-2.0d0*dran2(iseed),
     &                    1.0d0-2.0d0*dran2(iseed))
         do j = ilow(i), ihgh(i)
            aq(j) = ctmp*cmplx(1.0d0-2.0d0*dran2(iseed),
     &                         1.0d0-2.0d0*dran2(iseed))
         enddo
      enddo

      OPEN(4,file='SRC/SOLVER/iseed.dat')
          iseed = dran2(iseed)*700000
          write(4,*) iseed
      CLOSE(4)

      CALL slvinit_un(lda,n,ia,ilow,ns,irep,aq,lft,ptscmb,ncmb,
     &                 nrts,roots0,rtlow,rthgh,nrmlv,
     &                 a,u,b1,b,ca)

      CALL nlhom_un(lda,n,ia,ns,irep,aq,lft,ilow,ihgh,ptscmb,ncmb,
     &              nrmlv,roots0,roots1,nrts,ntimes,rtlow,rthgh,
     &              tpwr,p0,p1,p2,v1,v2,ca,b,p3,cf)
!     ca = dhz, b = h

c     CALL dtime(time)
c     WRITE(10,*) 'CPU time for nonlinear homotopy : ', time(1)

      CLOSE(10)

      OPEN(UNIT=2, FILE='for.fllwcrv')
         DO i = ilow(1), ihgh(n)
            WRITE(2,*) aq(i)
         ENDDO
         WRITE(2,*) rthgh(ncmb)
         DO j = 1, rthgh(ncmb)
            WRITE(2,*) ntimes(j)
            DO i = 1, n
               WRITE(2,*) roots1(i,j)
            ENDDO
         ENDDO
      CLOSE(2)

      STOP
      END
